#!/usr/bin/env python

# This script was briefly used to bulk fetch ALMA data for reingestion.

import os
import os.path

from pycapo import CapoConfig
import cx_Oracle as db

def connect():
    config = CapoConfig(profile='nmprod')

    user   = config['almaMetadataDatabase.jdbcUsername']
    passwd = config['almaMetadataDatabase.jdbcPassword']
    url    = config['almaMetadataDatabase.jdbcUrl']

    hostport, service_name = url.split('/')[-2:]
    host, port = hostport.split(':')
    dsn = db.makedsn(host, port, service_name=service_name.upper())
    return db.connect(user, passwd, dsn)

def fetchall():
    conn = connect()
    cur = conn.cursor()
    cur.execute("select EXECBLOCKUID from AQUA_V_EXECBLOCK WHERE QA0STATUS = 'Pass'")
    for (execblockuid,) in cur:
        fsname = execblockuid.replace(':', '_').replace('/', '_')
        if os.path.exists(fsname):
            print('Skipping {} (already exists on filesystem)'.format(execblockuid))
        else:
            retrieve(execblockuid)

def retrieve(execblockuid):
    os.system('./alma-data-fetcher.sh . SDM_ONLY {}'.format(execblockuid))

if __name__ == '__main__':
    fetchall()